'use strict';

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _parseInt = require('lodash/parseInt');

var _parseInt2 = _interopRequireDefault(_parseInt);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var rejectEmptyStrings = require('./rejectEmptyStrings');

var tagsRegex = /\B#\w+(:\s*\S*)?/g;

var parseText = _ramda2.default.pipe(_ramda2.default.replace(/\B#\w*(:\s*\S*)?/g, ''), // remove tags
_ramda2.default.replace(/\B@\w*(.\w*)*/g, ''), // remove mentions
_ramda2.default.replace(/\s+/g, ' '), // clean up spaces
_ramda2.default.trim);

var parseMentions = _ramda2.default.pipe(_ramda2.default.match(/@(\w+)(.\w*)*/g), // match references
_ramda2.default.map(_ramda2.default.tail), rejectEmptyStrings, _ramda2.default.map(_ramda2.default.pipe(_ramda2.default.trim, _ramda2.default.split('.'), rejectEmptyStrings, _ramda2.default.map(_ramda2.default.when(_ramda2.default.test(/^\d/), // Starts with a digit
_parseInt2.default // Convert to number
)))));

var parseTagContent = _ramda2.default.converge(function (text, references) {
	return { text: text, references: references };
}, [parseText, parseMentions]);

var parseTags = _ramda2.default.pipe(_ramda2.default.match(tagsRegex), // match tags,
_ramda2.default.map(_ramda2.default.pipe(_ramda2.default.match(/\B#([a-zA-Z0-9-_]+)(:\s*(\S*))?/), // capture tag elements,
_ramda2.default.props([1, 3]), _ramda2.default.adjust(_ramda2.default.pipe(_ramda2.default.when(_ramda2.default.is(String), parseTagContent), _ramda2.default.defaultTo(true)), 1))), _ramda2.default.fromPairs);

var parseElement = _ramda2.default.converge(function (text, tags, references) {
	return { text: text, tags: tags, references: references, children: [] };
}, [parseText, parseTags, _ramda2.default.pipe(_ramda2.default.replace(tagsRegex, ''), parseMentions)]);

module.exports = parseElement;